<?php
/**
 * @file
 * OM Subthemer Layout Engine
 */

/**
 * index.html - generates divs according to current layout
 *
 */ 
function om_subthemer_html_layout($divs) {
	static $output = '';       //init output
  global $om_layout_content; //layout array
  global $om_regions;        //regions
    	
  global $om_count;       //count number of arrays
  static $count = 0;    //count recursion, if equals number of arrays it will start the output

	$div_count = 0;       //init every level count of div
	$div_count_total = 0; //init every level total of div

	static $level = 1;    //count level for indents on divs on html file
	$tab = '';            //init tab for indents on divs on html file
	
	// For source layout
	// calculates number of tabs
	for($i = 1; $i < $level; $i++) {
		$tab .= "\t";
	}
	
	//read array
  foreach ($divs as $cid => $prop) {
  	$div_count++;
  	$div_count_total = count($divs); //counts inner divs
  	
	  $classes = om_layout_classes($div_count_total, $div_count, $prop);
	  
		$tagname = $prop['tagid'];
		$tagid = strtolower(preg_replace('/ /', '-', $prop['tagid']));
		$tagvar = strtolower(preg_replace('/ /', '_', $prop['tagid']));
		    
		$wrapper_div = "\n$tab<div id=\"" . $tagid . '" class="wrapper wrapper-' . $tagid . $classes . '">';
    $region_div = "\n$tab<div id=\"" . $tagid . '" class="region region-' . $tagid . $classes . '">';
		
		$ending = '</div><!-- /#' . $tagid . ' -->';
				
		//inner wrapper switch
		if ($prop['iw']) { 
			$wrapper_div .= '<div id="' . $tagid . '-inner" class="wrapper-inner">';
			$ending     = '</div></div><!-- /#' . $tagid . '-inner, /#' . $tagid . ' -->';
		} 
					
    if (isset($om_layout_content[$cid])) { //start recursion of div id is a parent
			$level++;  //add level
			$output .= $wrapper_div;
      om_subthemer_html_layout($om_layout_content[$cid]); //start recursion
      $output .= "\n$tab" . $ending;
    } else {
      if (($prop['type'] != 'variable') && ($tagname != 'Footer Message' )) $om_regions[] = $tagname;
      $output .= om_div_html_content($tagname, $tagid, $tagvar, $region_div, $ending, $prop['iw']);
		}

		//adds float clear below the columns
		if (($prop['type'] == 'column') && ($div_count == $div_count_total)) $output .= "\n$tab<div class=\"clearfix\"></div>";
  }
	$count++;
	//print $count;
	//switch to start the output
  if($count == $om_count) return $output;
}


/**
 * index.php - generates divs according to current layout
 *
 */ 
function om_subthemer_php_layout($divs) {
	static $output = '';  //init output
  global $om_layout_content;      //layout array
	
  global $om_count;       //count number of arrays
  static $count = 0;    //count recursion, if equals number of arrays it will start the output

	$div_count = 0;       //init every level count of div
	$div_count_total = 0; //init every level total of div

	static $level = 0;    //count level for indents on divs on html file
	$level++;    //count level for indents on divs on html file
	$tab = '';            //init tab for indents on divs on html file
	
	// For source layout
	// calculates number of tabs
	for($i = 1; $i < $level; $i++) {
		$tab .= "\t";
	}
	
	//read array
  foreach ($divs as $cid => $prop) {
  	$div_count++;
  	$div_count_total = count($divs); //counts inner divs
  	
  	// additional classes
	  $classes = om_layout_classes($div_count_total, $div_count, $prop);
	  
	  // div id, variable name
		$tagname = $prop['tagid'];
		$tagid = strtolower(preg_replace('/ /', '-', $prop['tagid']));
		$tagvar = strtolower(preg_replace('/ /', '_', $prop['tagid']));
		
		// wrapper div    
		$wrapper_div = "\n$tab<div id=\"" . $tagid . '" class="wrapper wrapper-' . $tagid . $classes . '">';
		
		// wrapper classes
		//$region_classes = 'region region-' . $tagid . ' ' . $classes;

    if(isset($om_layout_content[$cid])) { //start recursion of div id is a parent
			// ending without inner wrapper
		  $ending = '</div><!-- /#' . $tagid . ' -->';

		  //inner wrapper switch
		  if($prop['iw']) {
		    // ending with inner wrapper 
			  $wrapper_div .= '<div id="' . $tagid . '-inner" class="wrapper-inner">';
			  $ending      = '</div></div><!-- /#' . $tagid . '-inner/#' . $tagid . ' -->';
		  } 
			$output .= $wrapper_div;
      om_subthemer_php_layout($om_layout_content[$cid]); //start recursion
      $output .= "\n$tab" . $ending;
    } else {
      $output .= "\n$tab" . om_div_php_content($tagid, $tagvar, $prop['type'], $prop['iw']);
			//$output .= "\n$tab\t<h3 class=\"region-title\">" . $tagname . '</h3>';
		}
		//adds float clear below the columns
		if (($prop['type'] == 'column') && ($div_count == $div_count_total)) $output .= "\n$tab<div class=\"clearfix\"></div>";
  }
	$count++;
	//print $count;
	//switch to start the output
  if($count == $om_count) return $output;
}

/**
 * Get default div php content
 *
 */ 
function om_div_html_content($tagname = NULL, $tagid = NULL, $tagvar = NULL, $region_div = NULL, $ending = NULL, $iw = NULL) {
  $node = node_load(arg(1));
  
  $region_content = "\n$tab\t<h3 class=\"region-title\">" . $tagid . '</h3>';	
  
  if ($iw) { 
    $region_div  .= '<div id="' . $tagid . '-inner" class="region-inner">';
    $ending = '</div></div><!-- /#' . $tagid . '-inner, /#' . $tagid . ' -->';
	} 
  
  // check for reserved variable names
  $type = om_reserved_variables($tagname, '');
  
  $content = om_get_variable_content($tagvar, $node);
  
  if ($type == 'variable') {
    // gets contents from files whether empty of not
    return $content; 
  }
  elseif (!empty($content)) {
    // other regions will get contents from files if it exists
    return $content; 
  }
  else {
    // just blank div with tag name
    return $region_div . $region_content . $ending;		
  }
}


/**
 * Get default div php content
 *
 */ 
function om_div_php_content($tagid = NULL, $tagvar = NULL, $type = NULL, $iw = NULL) {

  // check for reserved variable names
  $type = om_reserved_variables($tagname, $type);
  
  if ($tagvar == 'identity') {
    $content = '<?php print theme(\'identity\', $logo, $site_name, $site_slogan, $front_page); ?>'; 
  }
  elseif ($tagvar == 'main_menu') {
    $content = '<?php print theme(\'menu\', \'main-menu\', $main_menu, $main_menu_tree); ?>';
  }
  elseif ($tagvar == 'secondary_menu') {
    $content = '<?php print theme(\'menu\', \'secondary-menu\', $secondary_menu, $secondary_menu_tree); ?>';
  }  
  elseif ($tagvar == 'content_elements') {
    $content = '<?php print theme(\'content_elements\', $mission, $tabs, $title) ?>';
  }  
  elseif ($tagvar == 'search_box') {
    $content = '<?php print theme(\'search_box\', $search_box); ?>';
  }  
  elseif ($type == 'variable') {
    $content = '<?php print $' . $tagvar . '; ?>'; 
  }
  else {
    $content = '<?php print theme(\'region\', \'' . $tagid . '\', $' . $tagvar . ', ' . $iw . '); ?>';	
  }
	return $content;
}


/**
 * Generates divs classess
 *
 */ 
function om_layout_classes($div_count_total = NULL, $div_count = NULL, $prop = array()) {
  $classes = '';
	  
  // row/column class
  $type = $prop['type']; 
	$classes .= ' ' . $type;
		
	// row/column-total
	$classes .= ' ' . $type . '-' . $div_count_total;
    
  // row/column-total-count row/column-count
	$classes .= ' ' . $type . '-' . $div_count_total . '-' . $div_count;
	$classes .= ' ' . $type . '-' . $div_count;
		
	// first/last
	if ($div_count == 1) $classes .= ' first';
	if ($div_count == $div_count_total) $classes .= ' last';
		
	// wrapper-outer
	if ($prop['pid'] == 0) $classes .= ' wrapper-outer';
	
  return $classes;
}


/**
 * Get Content
 *
 * @param $content
 *   Variable name
 * @param $node
 *
 */
function om_get_variable_content($content = NULL, $node) {
  $file = drupal_get_path('module', 'om_subthemer') .'/contents/' . $content . '.txt';
  
  if (is_file($file)) {
    $file_content = file_get_contents($file);
    //dsm($file_content);
    // loads content
    if (!empty($file_content)) {
      ob_start();
      eval($file_content);
      ob_end_clean();
    }
    else {
      // prevents returning the variable name
      $content = '';
    }
  }
  else {
    // prevents returning the variable name
    $content = '';
  }

  return $content;
}





